config/routes.rb
Rails.application.routes.draw do
  root 'interviews#index'

  resources :interviews do
    member do
      get :set_date, controller: :set_interview_date, action: :new
      post :set_date, controller: :set_interview_date, action: :create

      get :suggest_date, controller: :suggest_interview_date, action: :new
      post :suggest_date, controller: :suggest_interview_date, action: :create
    end
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/concerns/interview/with_events.rb
class Interview < ApplicationRecord
  module WithEvents
    extend ActiveSupport::Concern

    included do
      has_many :events, class_name: 'Interview::Event'

      EVENT_ATTRIBUTES = %i(interview_date suggested_date).freeze

      # add event attributes as methods on interview
      EVENT_ATTRIBUTES.each do |attribute|
        define_method attribute do
          # find last event that defined this attribute
          events.reverse.find do |event|
            event.respond_to?(attribute)
          end.try!(attribute)
        end
      end
    end

    def emit_event(klass, arguments = {})
      klass.new(arguments.merge(interview: self)).tap do |event|
        # if save was successful, reload so that event relation is updated
        reload if event.save
      end
    end
  end
end

app/models/interview.rb
class Interview < ApplicationRecord
  include Interview::WithEvents

  validates :candidate_name, presence: true
  validates :job_name, presence: true
  validates :company_name, presence: true

  # strip and presence each string before giving it to validation
  normalize :candidate_name, :job_name, :company_name
end

app/models/interview/event.rb
class Interview::Event < ApplicationRecord
  belongs_to :interview

  validates :interview, presence: true

  ISO_DATE_REGEX = /\A[0-9]{4}-[0-9]{2}-[0-9]{2}\z/.freeze
end

app/models/interview/event/set_interview_date.rb
class Interview::Event::SetInterviewDate < Interview::Event
  # we add a virtual accessor interview_date which
  # is serialized into the event data
  store :data, accessors: %i(interview_date)

  validates :interview_date,
            presence: true,
            format: { with: ISO_DATE_REGEX, message: 'not iso format' }
end

app/models/interview/event/suggest_interview_date.rb
class Interview::Event::SuggestInterviewDate < Interview::Event
  # we add a virtual accessor interview_date which
  # is serialized into the event data
  store :data, accessors: %i(suggested_date)

  validates :suggested_date,
            presence: true,
            format: { with: ISO_DATE_REGEX, message: 'not iso format' }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/interviews_controller.rb
class InterviewsController < ApplicationController
  before_action :set_interview, only: %i(show edit update destroy)

  def index
    @interviews = Interview.all
  end

  def show; end

  def new
    @interview = Interview.new
  end

  def edit; end

  def create
    @interview = Interview.new(interview_params)

    if @interview.save
      redirect_to @interview, notice: 'Interview was successfully created.'
    else
      render :new
    end
  end

  def update
    if @interview.update(interview_params)
      redirect_to @interview, notice: 'Interview was successfully updated.'
    else
      render :edit
    end
  end

  def destroy
    @interview.destroy
    redirect_to interviews_url, notice: 'Interview was successfully destroyed.'
  end

  private

  def set_interview
    @interview = Interview.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def interview_params
    params.require(:interview).permit(:candidate_name, :company_name, :job_name)
  end
end

app/controllers/set_interview_date_controller.rb
class SetInterviewDateController < ApplicationController
  before_action :interview, only: %i(new create)

  def new
    @interview_event = Interview::Event::SetInterviewDate.new(interview: interview)
  end

  def create
    @interview_event = interview.emit_event(Interview::Event::SetInterviewDate, interview_params)

    if @interview_event.persisted?
      redirect_to interview, notice: 'Interview date was successfully set.'
    else
      render :new
    end
  end

  private

  def interview
    @interview ||= Interview.find(params[:id])
  end

  def interview_params
    params.require(:interview_event).permit(:interview_date)
  end
end

app/controllers/suggest_interview_date_controller.rb
class SuggestInterviewDateController < ApplicationController
  before_action :interview, only: %i(new create)

  def new
    @interview_event = Interview::Event::SuggestInterviewDate.new(interview: interview)
  end

  def create
    @interview_event = interview.emit_event(Interview::Event::SuggestInterviewDate, interview_params)

    if @interview_event.persisted?
      redirect_to interview, notice: 'Interview date was successfully suggested.'
    else
      render :new
    end
  end

  private

  def interview
    @interview ||= Interview.find(params[:id])
  end

  def interview_params
    params.require(:interview_event).permit(:suggested_date)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/interviews_helper.rb
module InterviewsHelper
end

app/views/interviews/_form.html.erb
<%= form_with(model: interview, local: true) do |form| %>
  <% if interview.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(interview.errors.count, "error") %> prohibited this interview from being saved:</h2>

      <ul>
      <% interview.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :candidate_name %>
    <%= form.text_field :candidate_name %>
  </div>

  <div class="field">
    <%= form.label :company_name %>
    <%= form.text_field :company_name %>
  </div>

  <div class="field">
    <%= form.label :job_name %>
    <%= form.text_field :job_name %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/interviews/edit.html.erb
<h1>Editing Interview</h1>

<%= render 'form', interview: @interview %>

<%= link_to 'Show', @interview %> |
<%= link_to 'Back', interviews_path %>

app/views/interviews/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Interviews</h1>

<table>
  <thead>
    <tr>
      <th>Expert name</th>
      <th>Company name</th>
      <th>Job name</th>
      <th>Suggested Date</th>
      <th>Interview Date</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @interviews.each do |interview| %>
      <tr>
        <td><%= interview.candidate_name %></td>
        <td><%= interview.company_name %></td>
        <td><%= interview.job_name %></td>
        <td><%= interview.suggested_date =%></td>
        <td><%= interview.interview_date =%></td>
        <td><%= link_to 'Show', interview %></td>
        <td><%= link_to 'Edit', edit_interview_path(interview) %></td>
        <td><%= link_to 'Destroy', interview, method: :delete, data: { confirm: 'Are you sure?' } %></td>
        <td><%= link_to 'Suggest Interview Date', suggest_date_interview_path(interview) %></td>
        <td><%= link_to 'Set Interview Date', set_date_interview_path(interview) %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Interview', new_interview_path %>

app/views/interviews/new.html.erb
<h1>New Interview</h1>

<%= render 'form', interview: @interview %>

<%= link_to 'Back', interviews_path %>

app/views/interviews/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Candidate name:</strong>
  <%= @interview.candidate_name %>
</p>

<p>
  <strong>Company name:</strong>
  <%= @interview.company_name %>
</p>

<p>
  <strong>Job name:</strong>
  <%= @interview.job_name %>
</p>

<p>
  <strong>Suggested date:</strong>
  <%= @interview.suggested_date %>
</p>

<p>
  <strong>Interview date:</strong>
  <%= @interview.interview_date %>
</p>

<%= link_to 'Edit', edit_interview_path(@interview) %> |
<%= link_to 'Back', interviews_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Interstaffo</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all' %>
    <%= javascript_include_tag 'application' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/set_interview_date/_form.html.erb
<%= form_with(model: interview_event, local: true, url: set_date_interview_path(@interview), scope: :interview_event) do |form| %>
  <% if interview_event.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(interview_event.errors.count, "error") %> prohibited this interview from being saved:</h2>

      <ul>
      <% interview_event.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :interview_date %>
    <%= form.text_field :interview_date %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/set_interview_date/new.html.erb
<h1>Set Interview Date</h1>

<%= render 'form', interview_event: @interview_event %>

<%= link_to 'Back', interview_path(@interview) %>

app/views/suggest_interview_date/_form.html.erb
<%= form_with(model: interview_event, local: true, url: suggest_date_interview_path(@interview), scope: :interview_event) do |form| %>
  <% if interview_event.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(interview_event.errors.count, "error") %> prohibited this interview from being saved:</h2>

      <ul>
      <% interview_event.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :suggested_date %>
    <%= form.text_field :suggested_date %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/suggest_interview_date/new.html.erb
<h1>Suggest Interview Date</h1>

<%= render 'form', interview_event: @interview_event %>

<%= link_to 'Back', interview_path(@interview) %>